SystemOrganization addCategory: #'MC2-Squeak-Tests'!
SystemOrganization addCategory: #'MC2-Squeak-Adaptors'!
SystemOrganization addCategory: #'MC2-Squeak-Fakes'!
SystemOrganization addCategory: #'MC2-Squeak-Slices'!
SystemOrganization addCategory: #'MC2-Squeak-UI'!

Object subclass: #MDCommentDialog
	instanceVariableNames: 'slice meta comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-UI'!

!MDCommentDialog class methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 18:09'!
slice: slice
	^ self
		slice: slice
		meta: (MDSliceOrganizer default infoMatching: slice)! !

!MDCommentDialog class methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 01:01'!
slice: slice meta: meta
	^ self basicNew setSlice: slice meta: meta! !

!MDCommentDialog methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 16:23'!
buildWith: aBuilder
	| windowSpec textSpec |
	windowSpec _ aBuilder pluggableWindowSpec new.
	windowSpec
		model: self;
		name: 'window';
		label: 'Monticello Commit';
		extent: 400 @ 400;
		children: OrderedCollection new.

	textSpec := aBuilder pluggableTextSpec new.
	textSpec
		model: self;
		name: 'name';
		getText: #versionName;
		frame: (0.0@0.0 corner: 1.0@0.1).
	windowSpec children add: textSpec.

	textSpec := aBuilder pluggableTextSpec new.
	textSpec
		model: self;
		name: 'message';
		getText: #comment;
		selection: #selection;
		setText: #comment:;
		frame: (0.0@0.1 corner: 1.0@1.0).
	windowSpec children add: textSpec.
	
	^ aBuilder build: windowSpec! !

!MDCommentDialog methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 16:04'!
comment
	^ comment ifNil: [self defaultComment]! !

!MDCommentDialog methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 16:05'!
comment: aText
	| trimmed |
	trimmed _ aText asString withBlanksTrimmed.
	comment _ trimmed = self defaultComment ifFalse: [trimmed]! !

!MDCommentDialog methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 16:05'!
defaultComment
	^ 'enter log message here'! !

!MDCommentDialog methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 14:25'!
open
	^ ToolBuilder open: self! !

!MDCommentDialog methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 16:24'!
openModally
	| window |
	window _ self open.
	[comment = self defaultComment]
		whileTrue: [window outermostWorldMorph doOneCycle].
	window delete.
	^ comment! !

!MDCommentDialog methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 16:25'!
selection
	^ 1 to: self comment size! !

!MDCommentDialog methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 16:24'!
setSlice: sliceProps meta: metaProps
	slice _ sliceProps.
	meta _ metaProps.
	comment _ self defaultComment! !

!MDCommentDialog methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 01:06'!
versionName
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: slice name;
			nextPut: $-;
			nextPutAll: meta author;
			nextPut: $.;
			print: meta ordinal]! !

Object subclass: #MDFakeClassDescription
	instanceVariableNames: 'superclass methodDict format instanceVariables organization name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!

MDFakeClassDescription subclass: #MDFakeClass
	instanceVariableNames: 'subclasses classPool sharedPools environement category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!

!MDFakeClass class methodsFor: 'instance creation' stamp: 'cwp 8/27/2005 11:50'!
basedOn: aClass
	^ self new initializeFromClass: aClass theNonMetaClass! !

!MDFakeClass methodsFor: 'mutation' stamp: 'cwp 8/27/2005 10:37'!
addClassVarName: aString
	classPool at: aString asSymbol put: nil! !

!MDFakeClass methodsFor: 'mutation' stamp: 'cwp 8/28/2005 16:11'!
addSharedPool: aSharedPool 
	(self sharedPools includes: aSharedPool)
		ifTrue: [^self error: 'This is already in my shared pool list'].
	sharedPools == nil
		ifTrue: [sharedPools _ OrderedCollection with: aSharedPool]
		ifFalse: [sharedPools add: aSharedPool]! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
category
	^category! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
category: anObject
	category := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
classPool
	^classPool! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
classPool: anObject
	classPool := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 10:48'!
classVarNames
	^ classPool keys! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
environement
	^environement! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
environement: anObject
	environement := anObject! !

!MDFakeClass methodsFor: 'initialize-release' stamp: 'cwp 8/28/2005 16:43'!
initializeFromClass: aClass
	superclass _ aClass superclass.
	methodDict _ aClass methodDict copy.
	format _ aClass format.
	name _ aClass name.
	organization _ aClass organization copy.
	instanceVariables _ aClass instVarNames.
	classPool _ aClass classPool copy.
	sharedPools _ aClass sharedPools copy.
	! !

!MDFakeClass methodsFor: 'testing' stamp: 'cwp 8/27/2005 12:50'!
isMeta
	^ false! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
sharedPools
	^sharedPools! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
sharedPools: anObject
	sharedPools := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
subclasses
	^subclasses! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
subclasses: anObject
	subclasses := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theMetaClass
	^MDFakeMetaclass basedOn: self theRealClass class! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:52'!
theNonMetaClass
	^ self! !

!MDFakeClassDescription methodsFor: 'mutation' stamp: 'cwp 8/27/2005 11:36'!
addInstVarName: aString
	instanceVariables _ instanceVariables copyWith: aString! !

!MDFakeClassDescription methodsFor: 'copying' stamp: 'cwp 8/27/2005 11:36'!
copy
	^ self class basedOn: self! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
format
	^format! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
format: anObject
	format := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
instVarNames
	^ instanceVariables! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
instVarNames: anArray
	instanceVariables _ anArray! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
methodDict
	^methodDict! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
methodDict: anObject
	methodDict := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:38'!
name
	^ name! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:38'!
name: aSymbol
	name _ aSymbol! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
organization
	^organization! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
organization: anObject
	organization := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
superclass
	^superclass! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
superclass: anObject
	superclass := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theRealClass
	^Smalltalk classNamed: name! !

MDFakeClassDescription subclass: #MDFakeMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!

!MDFakeMetaclass class methodsFor: 'as yet unclassified' stamp: 'cwp 8/27/2005 11:56'!
basedOn: aMetaclass
	^ self new initializeFromMetaclass: aMetaclass theMetaClass! !

!MDFakeMetaclass methodsFor: 'initialize-release' stamp: 'cwp 8/27/2005 11:53'!
initializeFromMetaclass: aMetaclass
	superclass _ aMetaclass superclass.
	methodDict _ aMetaclass methodDict copy.
	format _ aMetaclass format.
	name _ aMetaclass theNonMetaClass name.
	organization _ aMetaclass organization copy.
	instanceVariables _ aMetaclass instVarNames.
! !

!MDFakeMetaclass methodsFor: 'testing' stamp: 'cwp 8/27/2005 12:50'!
isMeta
	^ true! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:53'!
name
	^ name, ' class'! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:52'!
theMetaClass
	^ self! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theNonMetaClass
	^ MDFakeClass basedOn: self theRealClass! !

Object subclass: #MDMergeTool
	instanceVariableNames: 'wc merges selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-UI'!

!MDMergeTool class methodsFor: 'instance creation' stamp: 'cwp 4/25/2005 03:59'!
on: anArray 
	^ self new merges: anArray! !

!MDMergeTool class methodsFor: 'instance creation' stamp: 'cwp 3/2/2006 14:55'!
on: anArray in: aWorkingCopy
	^ self new 
		merges: anArray;
		workingCopy: aWorkingCopy;
		yourself! !

!MDMergeTool class methodsFor: 'opening' stamp: 'cwp 4/24/2005 23:02'!
openOn: anArray 
	^ ToolBuilder open: (self on: anArray)! !

!MDMergeTool class methodsFor: 'opening' stamp: 'avi 3/20/2006 10:53'!
openOn: anArray in: aWorkingCopy
	^ ToolBuilder open: (self on: anArray in: aWorkingCopy)! !

!MDMergeTool methodsFor: 'interface' stamp: 'cwp 6/19/2005 19:47'!
addChooseLocalTo: aMenuSpec 
	aMenuSpec 
		add: 'choose local'
		target: self
		selector: #resolveUsing:
		argumentList: (Array with: #chooseLocal)! !

!MDMergeTool methodsFor: 'interface' stamp: 'cwp 6/19/2005 19:48'!
addChooseRemoteTo: aMenuSpec 
	^aMenuSpec 
		add: 'choose remote'
		target: self
		selector: #resolveUsing:
		argumentList: (Array with: #chooseRemote)! !

!MDMergeTool methodsFor: 'interface' stamp: 'avi 3/22/2006 20:02'!
buildWith: aBuilder 
	| windowSpec listSpec textSpec buttonSpec |
	windowSpec := aBuilder pluggableWindowSpec new.
	windowSpec
		model: self;
		name: 'window';
		label: 'Monticello Merge Tool';
		extent: 400 @ 400;
		children: OrderedCollection new.

	buttonSpec := aBuilder pluggableButtonSpec new.	
	buttonSpec 
		model: self;
		label: 'Include snapshot version';
		action: #chooseRemote;
		frame: (0 @ 0.5 extent: 0.5 @ 0.1).
	windowSpec children add: buttonSpec.

	buttonSpec := aBuilder pluggableButtonSpec new.	
	buttonSpec 
		model: self;
		label: 'Keep image version';
		action: #chooseLocal;
		frame: (0.5 @ 0.5 extent: 0.5 @ 0.1).
	windowSpec children add: buttonSpec.

	buttonSpec := aBuilder pluggableButtonSpec new.	
	buttonSpec 
		model: self;
		label: 'Merge resolved changes';
		action: #mergeResolved;
		frame: (0 @ 0 extent: 1 @ 0.1).
	windowSpec children add: buttonSpec.
	
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: 'elements';
		list: #elementList;
		menu: #elementListMenu:;
		getIndex: #elementListIndex;
		setIndex: #elementListIndex:;
		keyPress: nil;
		autoDeselect: false;
		frame: (0 @ 0.1 extent: 0.5 @ 0.4).
	windowSpec children add: listSpec.
	textSpec := aBuilder pluggableTextSpec new.
	textSpec
		model: self;
		name: 'local';
		getText: #localText;
		selection: #localSelection;
		setText: #localText:;
		frame: (0.5 @ 0.6 extent: 0.5 @ 0.4).
	windowSpec children add: textSpec.
	textSpec := aBuilder pluggableTextSpec new.
	textSpec
		model: self;
		name: 'remote';
		getText: #remoteText;
		selection: #remoteSelection;
		setText: #remoteText:;
		frame: (0 @ 0.6 extent: 0.5 @ 0.4).
	windowSpec children add: textSpec.
	textSpec := aBuilder pluggableTextSpec new.
	textSpec
		model: self;
		name: 'resolved';
		getText: #resolvedText;
		selection: #resolvedSelection;
		setText: #resolvedText:;
		frame: (0.5 @ 0.1 extent: 0.5 @ 0.4).
	windowSpec children add: textSpec.
	^aBuilder build: windowSpec! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'avi 3/22/2006 20:02'!
chooseLocal
	self resolveUsing: #chooseLocal! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'avi 3/22/2006 20:02'!
chooseRemote
	self resolveUsing: #chooseRemote! !

!MDMergeTool methodsFor: 'interface' stamp: 'cwp 4/24/2005 23:17'!
defaultBackgroundColor
	^ (Color r: 0.627 g: 0.69 b: 0.976)! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/9/2005 09:02'!
elementList
	^ merges collect: [:ea | ea isResolved 
							ifFalse: [ea displayString asText allBold]
							ifTrue: [ea displayString]]! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 5/26/2005 09:06'!
elementListIndex
	^ selection ifNil: [0]! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 5/30/2005 23:15'!
elementListIndex: anInteger 
	selection _ anInteger.
	self changed: #elementListIndex.
	self changed: #localText.
	self changed: #remoteText.
	self changed: #resolvedText.! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/19/2005 19:51'!
elementListMenu: aMenuSpec 
	aMenuSpec 
		add: 'merge resolved'
		target: self
		selector: #mergeResolved
		argumentList: #().
	self withSelectionDo: 
			[:sel | 
			sel isLocal ifFalse: [self addChooseLocalTo: aMenuSpec].
			sel isRemote ifFalse: [self addChooseRemoteTo: aMenuSpec]]
		ifNil: [].
	^aMenuSpec! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 4/25/2005 02:43'!
localSelection
	^ 1 to: 0! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 5/24/2005 08:10'!
localText
	^ self textFor: #local! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/15/2005 08:17'!
localText: aText
	self changed: #localText! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 3/2/2006 15:19'!
mergeResolved
	| resolved |
	resolved := self merges select: [:ea | ea isResolved].
	wc transaction: [resolved do: [:ea | ea applyTo: wc]].
	self merges: (self merges copyWithoutAll: resolved).
	selection _ 0.
	self changed: #elementList.
	self changed: #localText.
	self changed: #remoteText.
	self changed: #resolvedText.! !

!MDMergeTool methodsFor: 'accessing' stamp: 'cwp 4/25/2005 04:00'!
merges
	^merges! !

!MDMergeTool methodsFor: 'accessing' stamp: 'cwp 6/3/2005 08:39'!
merges: aCollection
	merges := (aCollection asSortedCollection: [:a :b | a isConflict]) asArray! !

!MDMergeTool methodsFor: 'interface' stamp: 'cwp 12/31/2006 14:22'!
open
	^ ToolBuilder open: self! !

!MDMergeTool methodsFor: 'private' stamp: 'cwp 6/17/2005 22:41'!
perform: aSelector orSendTo: anObject
	(self respondsTo: aSelector)
		ifTrue: [self perform: aSelector]
		ifFalse: [anObject perform: aSelector]! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/3/2005 08:20'!
remoteSelection
	^ 1 to: 0! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 5/24/2005 08:10'!
remoteText
	^ self textFor: #remote! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/15/2005 08:22'!
remoteText: aText
	self changed: #remoteText! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/9/2005 08:55'!
resolveUsing: aSelector
	self selectedMerge perform: aSelector.
	self changed: #resolvedText.
	self changed: #elementList.! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 4/25/2005 02:47'!
resolvedSelection
	^ 1 to: 0! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'avi 3/22/2006 19:58'!
resolvedText
	^ ((self textFor: #resolution) ifNil: ['-- unresolved conflict --']) asText allBold! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/15/2005 08:26'!
resolvedText: aText
	self changed: #resolvedText! !

!MDMergeTool methodsFor: 'accessing' stamp: 'cwp 6/19/2005 20:39'!
selectedMerge
	^ merges at: (selection ifNil: [^ nil]) ifAbsent: [^ nil]! !

!MDMergeTool methodsFor: 'private' stamp: 'cwp 3/2/2006 15:03'!
textFor: aSelector 
	^self withSelectionDo: 
			[:merge | 
			wc displayVersion: ((merge perform: aSelector) ifNil: [^nil])]
		ifNil: ['']! !

!MDMergeTool methodsFor: 'testing' stamp: 'cwp 12/21/2006 22:14'!
withSelectionDo: aMonadicValuable ifNil: aValuable 
	| selected |
	selected _ self selectedMerge.
	^ selected 
		ifNil: aValuable 
		ifNotNil: [aMonadicValuable value: selected]! !

!MDMergeTool methodsFor: 'accessing' stamp: 'cwp 3/2/2006 14:56'!
workingCopy
	^ wc	! !

!MDMergeTool methodsFor: 'accessing' stamp: 'cwp 3/2/2006 14:56'!
workingCopy: aWorkingCopy
	wc _ aWorkingCopy! !

Object subclass: #MDSlicePanel
	instanceVariableNames: 'stati index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-UI'!

MDSlicePanel subclass: #MDRepositoryPanel
	instanceVariableNames: 'repository store memos memoIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-UI'!

!MDRepositoryPanel class methodsFor: 'instance creation' stamp: 'cwp 12/23/2006 20:09'!
default
	^ self store: MDStore default ! !

!MDRepositoryPanel class methodsFor: 'instance creation' stamp: 'cwp 12/23/2006 20:10'!
on: aRepository
	^ self on: aRepository store: MDStore default! !

!MDRepositoryPanel class methodsFor: 'instance creation' stamp: 'cwp 12/23/2006 21:00'!
on: aRepository store: aStore
	aStore ensureRepository: aRepository.
	^ self withAllPackages
		repository: aRepository;
		store: aStore;
		yourself! !

!MDRepositoryPanel class methodsFor: 'instance creation' stamp: 'cwp 1/1/2007 01:34'!
openOnFileNamed: aString
	| repo |
	repo _ MDFileRepository named: aString.
	(MDRepositoryPanel on: repo) open.
	^ repo
! !

!MDRepositoryPanel class methodsFor: 'instance creation' stamp: 'cwp 1/1/2007 01:34'!
openOnMemory
	| repo |
	repo _ MDMemoryRepository new.
	(MDRepositoryPanel on: repo) open.
	^ repo! !

!MDRepositoryPanel class methodsFor: 'instance creation' stamp: 'cwp 12/23/2006 20:11'!
store: aStore
	^ self on: aStore repositories first store: aStore! !

!MDRepositoryPanel methodsFor: 'accessing' stamp: 'avi 3/20/2006 00:58'!
basicSliceListIndex: aNumber
	super sliceListIndex: aNumber! !

!MDRepositoryPanel methodsFor: 'building' stamp: 'cwp 1/19/2007 22:50'!
buildWith: aBuilder
		| windowSpec listSpec buttonSpec |
	windowSpec := aBuilder pluggableWindowSpec new.
	windowSpec
		model: self;
		name: 'window';
		label: repository description;
		extent: 400 @ 400;
		children: OrderedCollection new.
	
	buttonSpec := aBuilder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'Refresh';
		action: #updateMemos;
		frame: (0 @ 0 extent: 0.25 @ 0.1).
	windowSpec children add: buttonSpec.
	
	buttonSpec := aBuilder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'Save';
		action: #save;
		frame: (0.25 @ 0 extent: 0.25 @ 0.1).
	windowSpec children add: buttonSpec.

	buttonSpec := aBuilder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'Load';
		action: #load;
		frame: (0.5 @ 0 extent: 0.25 @ 0.1).
	windowSpec children add: buttonSpec.

	buttonSpec := aBuilder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'Include';
		action: #include;
		frame: (0.75 @ 0 extent: 0.25 @ 0.1).
	windowSpec children add: buttonSpec.
	
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: 'slices';
		list: #sliceList;
		menu: #sliceListMenu:;
		getIndex: #sliceListIndex;
		setIndex: #sliceListIndex:;
		keyPress: nil;
		autoDeselect: false;
		frame: (0 @ 0.1 corner: 0.5 @ 1).
	windowSpec children add: listSpec.

	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: 'snapshots';
		list: #memoList;
		menu: #memoMenu;
		getIndex: #memoIndex;
		setIndex: #memoIndex:;
		keyPress: nil;
		autoDeselect: false;
		frame: (0.5 @ 0.1 corner: 1 @ 1).
	windowSpec children add: listSpec.

	^ aBuilder build: windowSpec.! !

!MDRepositoryPanel methodsFor: 'actions' stamp: 'cwp 1/1/2007 12:42'!
include
	self selection slice include: self selectedSnapshot.! !

!MDRepositoryPanel methodsFor: 'initialize-release' stamp: 'cwp 1/19/2007 22:48'!
initialize
	super initialize.
	memoIndex _ 0! !

!MDRepositoryPanel methodsFor: 'actions' stamp: 'cwp 1/1/2007 12:42'!
load
	self selection load: self selectedSnapshot from: store.
	self changed: #sliceList! !

!MDRepositoryPanel methodsFor: 'callbacks' stamp: 'cwp 1/19/2007 22:48'!
memoIndex 
	^ memoIndex! !

!MDRepositoryPanel methodsFor: 'callbacks' stamp: 'cwp 1/19/2007 22:49'!
memoIndex: anInteger 
	memoIndex _ anInteger.
	memoIndex = 0 ifFalse: [self updateSliceSelection].
	self changed: #memoIndex.
! !

!MDRepositoryPanel methodsFor: 'callbacks' stamp: 'cwp 1/19/2007 22:51'!
memoList
	^ memos collect: [:ea | ea name]! !

!MDRepositoryPanel methodsFor: 'accessing' stamp: 'avi 3/19/2006 23:58'!
repository
	^ repository! !

!MDRepositoryPanel methodsFor: 'accessing' stamp: 'cwp 1/19/2007 22:47'!
repository: aRepository
	repository _ aRepository.
	self updateMemos! !

!MDRepositoryPanel methodsFor: 'actions' stamp: 'cwp 1/19/2007 22:47'!
save
	self selection saveTo: repository.
	self updateMemos! !

!MDRepositoryPanel methodsFor: 'accessing' stamp: 'cwp 1/19/2007 21:03'!
selectedMemo
	^ memos at: memoIndex ifAbsent: [^ nil]
		! !

!MDRepositoryPanel methodsFor: 'accessing' stamp: 'cwp 1/19/2007 21:05'!
selectedSnapshot
	^ (memos at: memoIndex ifAbsent: [^ nil])
		getSnapshotFrom: repository! !

!MDRepositoryPanel methodsFor: 'callbacks' stamp: 'cwp 1/19/2007 22:50'!
sliceListIndex: aNumber
	self basicSliceListIndex: aNumber.
	self memoIndex: 0! !

!MDRepositoryPanel methodsFor: 'accessing' stamp: 'cwp 12/23/2006 20:07'!
store
	^ store! !

!MDRepositoryPanel methodsFor: 'accessing' stamp: 'cwp 12/23/2006 20:07'!
store: aStore
	store _ aStore! !

!MDRepositoryPanel methodsFor: 'accessing' stamp: 'avi 3/20/2006 00:37'!
stringForMetadata: aSet
	| version |
	version _ aSet anyOne.
	^ version variant element asString, ' ', (version timestamp printFormat: '%m/%d/%Y %H:%M:%S')! !

!MDRepositoryPanel methodsFor: 'actions' stamp: 'cwp 1/19/2007 21:04'!
updateMemos
	memos _ repository memos asSortedCollection: [:a :b | a hashstamp <= b hashstamp].
	self changed: #memoList! !

!MDRepositoryPanel methodsFor: 'actions' stamp: 'cwp 1/19/2007 22:43'!
updateSliceSelection
	| memo |
	self basicSliceListIndex: 0.
	memo _ self selectedMemo.
	memo ifNotNil:
		[stati withIndexDo:
			[:ea :i |
			(memo matchesSlice: ea slice) ifTrue:
				[self basicSliceListIndex: i]]]! !

!MDRepositoryPanel methodsFor: 'callbacks' stamp: 'cwp 12/25/2006 16:16'!
windowIsClosing
	super windowIsClosing.
	store removeRepository: repository.
	repository close.! !

!MDSlicePanel class methodsFor: 'instance creation' stamp: 'cwp 3/3/2006 14:23'!
withAllPackages
	| inst slices |
	slices _ PackageInfo allPackages collect: [:ea | MDPackageInfoSlice forPackage: ea].
	inst _ self new.
	slices sort: [:a :b | a name <= b name].
	slices do: [:ea | inst addSlice: ea].
	^ inst! !

!MDSlicePanel methodsFor: 'accessing' stamp: 'cwp 8/24/2005 21:54'!
addSlice: aSlice
	^ self addSlice: aSlice of: MDWorkingCopy default! !

!MDSlicePanel methodsFor: 'accessing' stamp: 'cwp 8/24/2005 22:44'!
addSlice: aSlice of: aWorkingCopy 
	stati add: (MDSliceStatus forSlice: aSlice of: aWorkingCopy)! !

!MDSlicePanel methodsFor: 'accessing' stamp: 'cwp 8/24/2005 22:44'!
addStatus: aSliceStatus 
	stati add: aSliceStatus! !

!MDSlicePanel methodsFor: 'building' stamp: 'avi 3/20/2006 00:07'!
buildWith: aBuilder
		| windowSpec listSpec buttonSpec |
	windowSpec := aBuilder pluggableWindowSpec new.
	windowSpec
		model: self;
		name: 'window';
		label: 'Monticello Slices';
		extent: 250 @ 400;
		children: OrderedCollection new.
	
	buttonSpec := aBuilder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'Save';
		action: #save;
		frame: (0 @ 0 extent: 0.5 @ 0.1).
	windowSpec children add: buttonSpec.
	
	buttonSpec := aBuilder pluggableButtonSpec new.
	buttonSpec 
		model: self;
		label: 'Save to File';
		action: #saveToFile;
		frame: (0.5 @ 0 extent: 0.5 @ 0.1).
	windowSpec children add: buttonSpec.

	
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: 'slices';
		list: #sliceList;
		menu: #sliceListMenu:;
		getIndex: #sliceListIndex;
		setIndex: #sliceListIndex:;
		keyPress: nil;
		autoDeselect: false;
		frame: (0 @ 0.1 corner: 1 @ 1).
	windowSpec children add: listSpec.
	^ aBuilder build: windowSpec.! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 9/5/2005 17:29'!
classCommented: anEvent
	stati do: [:ea | ea isDirty ifFalse: [ea classCommented: anEvent]].
	self changed: #sliceList! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/28/2005 19:19'!
classModified: anEvent
	stati do: [:ea | ea isDirty ifFalse: [ea classModified: anEvent]].
	self changed: #sliceList! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 9/5/2005 17:27'!
classMoved: anEvent
	self classModified: anEvent! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 9/5/2005 17:28'!
classRemoved: anEvent
	^ self classModified: anEvent! !

!MDSlicePanel methodsFor: 'initialize-release' stamp: 'cwp 8/24/2005 22:44'!
initialize
	stati := OrderedCollection new.
	index := 0! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/29/2005 01:41'!
methodModified: anEvent
	stati do: [:ea | ea isDirty ifFalse: [ea methodModified: anEvent]].
	self changed: #sliceList! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/28/2005 19:15'!
methodMoved: anEvent
	self methodModified: anEvent! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/28/2005 19:12'!
methodRemoved: anEvent
	self methodModified: anEvent! !

!MDSlicePanel methodsFor: 'building' stamp: 'cwp 8/28/2005 19:17'!
open
	self register.
	ToolBuilder open: self! !

!MDSlicePanel methodsFor: 'actions' stamp: 'cwp 9/6/2005 00:24'!
perform: aSelector orSendTo: anObject
	(self respondsTo: aSelector)
		ifTrue: [self perform: aSelector]
		ifFalse: [anObject perform: aSelector]! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 9/5/2005 17:26'!
register
	SystemChangeNotifier uniqueInstance
		notify: self ofSystemChangesOfItem: #class change: #Added using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Modified using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Renamed using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Commented using: #classCommented:;
		notify: self ofSystemChangesOfItem: #class change: #Recategorized using: #classMoved:;	
		notify: self ofSystemChangesOfItem: #class change: #Removed using: #classRemoved:;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #methodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #methodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Recategorized using: #methodMoved:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #methodRemoved:! !

!MDSlicePanel methodsFor: 'actions' stamp: 'cwp 10/16/2005 12:19'!
save
	self selection save.
	self changed: #sliceList! !

!MDSlicePanel methodsFor: 'actions' stamp: 'cwp 10/16/2005 12:20'!
saveToFile
	self selection saveToFile.
	self changed: #sliceList.! !

!MDSlicePanel methodsFor: 'accessing' stamp: 'cwp 8/29/2005 21:48'!
selection
	^ stati at: index! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 8/24/2005 22:55'!
sliceList
	^stati collect: [:ea | ea displayString]! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 8/22/2005 23:57'!
sliceListIndex
	^ index! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 8/24/2005 21:35'!
sliceListIndex: anInteger 
	index _ anInteger.
	self changed: #sliceListIndex! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 12/22/2006 22:04'!
sliceListMenu: aMenuSpec
	^ aMenuSpec
		add: 'save to repository' target: self selector: #save;
		add: 'save to file' target: self selector: #saveToFile;
		yourself! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/28/2005 19:07'!
unregister
	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 8/28/2005 19:17'!
windowIsClosing
	self unregister
! !

Object subclass: #MDSliceStatus
	instanceVariableNames: 'slice wc isDirty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-UI'!

!MDSliceStatus class methodsFor: 'as yet unclassified' stamp: 'cwp 8/24/2005 21:55'!
forSlice: aSlice of: aWorkingCopy
	^ self new setSlice: aSlice wc: aWorkingCopy! !

!MDSliceStatus methodsFor: 'accessing' stamp: 'cwp 8/25/2005 23:16'!
beClean
	^ isDirty _ false.! !

!MDSliceStatus methodsFor: 'accessing' stamp: 'cwp 8/25/2005 23:16'!
beDirty
	^ isDirty _ true! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/28/2005 16:57'!
check: aSelector inEvent: anEvent as: aClass

	self 
		check: aSelector
		inEvent: anEvent
		as: aClass
		using: #yourself! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/28/2005 16:57'!
check: aSelector inEvent: anEvent as: aClass using: nameSelector

	| changed element |
	changed := (anEvent oldItem perform: aSelector)
				 disjoin: (anEvent item perform: aSelector).
	changed do: [:ea | 
				element := aClass 
							className: anEvent itemClass theNonMetaClass name
							name: (ea perform: nameSelector).
				(self eventWithElement: element) ifTrue: [^ self]].
! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 9/5/2005 20:26'!
classCommented: anEvent
	self eventWithElement: (MDClassCommentElement className: anEvent item name)! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'avi 9/5/2005 19:57'!
classModified: anEvent 
	| element |
	anEvent itemClass isMeta ifTrue: [^self metaclassModified: anEvent].
	element := MDClassElement className: anEvent itemClass name.
	(self eventWithElement: element) ifTrue: [^self].
	anEvent isModified ifFalse: [^ self].
	self
		check: #instVarNames
			inEvent: anEvent
			as: MDInstVarElement;
		check: #classVarNames
			inEvent: anEvent
			as: MDClassVarElement;
		check: #sharedPools
			inEvent: anEvent
			as: MDPoolImportElement
			using: #name! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/28/2005 18:57'!
classMoved: anEvent
	! !

!MDSliceStatus methodsFor: 'accessing' stamp: 'cwp 8/24/2005 23:13'!
displayString
	^( self isDirty
		ifTrue: ['* ']
		ifFalse: ['  ']), self name! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/29/2005 01:37'!
eventWithElement: element
	(slice includes: element) ifTrue: [^ self beDirty].
	^ false! !

!MDSliceStatus methodsFor: 'testing' stamp: 'cwp 8/24/2005 23:16'!
isDirty
	^ isDirty! !

!MDSliceStatus methodsFor: 'actions' stamp: 'cwp 12/23/2006 22:14'!
load: aSnapshot from: aRepository
	slice
		load: aSnapshot
		from: aRepository
		to: wc.
	self beClean.! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 9/4/2005 00:41'!
metaclassModified: anEvent 
	self 
		check: #instVarNames
		inEvent: anEvent
		as: MDClassInstVarElement! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/29/2005 19:47'!
methodModified: anEvent
	| element |
	element := MDMethodElement 
				className: anEvent itemClass theNonMetaClass name 
				selector: anEvent itemSelector
				classIsMeta: anEvent itemClass isMeta.
	self eventWithElement: element.! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/28/2005 18:56'!
methodRemoved: anEvent 
	self methodModified: anEvent! !

!MDSliceStatus methodsFor: 'accessing' stamp: 'cwp 8/24/2005 21:57'!
name
	^ slice name! !

!MDSliceStatus methodsFor: 'actions' stamp: 'cwp 9/4/2005 00:26'!
save
	slice save.
	self beClean! !

!MDSliceStatus methodsFor: 'actions' stamp: 'avi 3/19/2006 23:59'!
saveTo: aRepository
	slice saveFrom: MDWorkingCopy default to: aRepository.
	self beClean! !

!MDSliceStatus methodsFor: 'actions' stamp: 'cwp 10/16/2005 12:29'!
saveToFile
	| name |
	name := UIManager current request: 'file name'.
	slice saveFrom: wc toFileNamed: name.
	self beClean! !

!MDSliceStatus methodsFor: 'initialize-release' stamp: 'cwp 8/24/2005 23:16'!
setSlice: aSlice wc: aWorkingCopy
	slice _ aSlice.
	wc _ aWorkingCopy.
	isDirty _ false.! !

!MDSliceStatus methodsFor: 'accessing' stamp: 'cwp 10/16/2005 12:08'!
slice
	^ slice! !

Object subclass: #MDSqueakElementAdaptor
	instanceVariableNames: 'element system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

MDSqueakElementAdaptor subclass: #MDSqueakClassAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
category
	^ self elementClass category! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
classVariablesString
	^ self send: #classVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 12/2/2005 22:47'!
elementClass
	^ system at: element theClassName ifAbsent: [nil]! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
format
	^ self elementClass typeOfClass! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
instanceVariablesString
	^ self send: #instanceVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:31'!
isLoadable: properties 
	self superclassFrom: properties ifAbsent: [^ false].
	^ true! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 12/1/2005 22:31'!
isPresent
	^ (system at: element theClassName ifAbsent: [^ false])
		isBehavior! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 22:25'!
load: properties
	| superClass |
	superClass _ Smalltalk at: properties superclassName.
	ClassBuilder new
		name: element theClassName 
		inEnvironment: superClass environment 
		subclassOf: superClass
		type: properties format 
		instanceVariableNames: self instanceVariablesString 
		classVariableNames: self classVariablesString 
		poolDictionaries: self sharedPoolsString
		category: properties category
! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/5/2005 23:02'!
propertyNames
	^ #(category format superclassName)! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:39'!
remove
	self elementClass ifNotNilDo: [:class | class removeFromSystem]! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:39'!
send: aSelector toClassIfNil: aBlock
	| class |
	class := self elementClass.
	^ class 
		ifNotNil: [class perform: aSelector]
		ifNil: aBlock! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:31'!
sharedPoolsString
	^ self send: #sharedPoolsString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 12/1/2005 23:12'!
superclassFrom: properties ifAbsent: absentBlock 
	| global |
	global _ system 
				at: properties superclassName 
				ifAbsent: [^ absentBlock value].
	^ (global isBehavior)
		ifTrue: [global]
		ifFalse: absentBlock! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:40'!
superclassName
	^ self elementClass superclass name! !

MDSqueakElementAdaptor subclass: #MDSqueakClassCommentAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:22'!
isPresent
	^ self elementClass hasComment! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:55'!
load: properties
	self elementClass
		classComment: properties text
		stamp: (self stampFromProperties: properties)! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:29'!
propertyNames
	^ #(text author timeStamp)! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:59'!
remove
	self elementClass organization classComment: nil stamp: nil.
! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:34'!
stamp
	^ self elementClass organization commentStamp! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 3/11/2005 21:02'!
text
	^ self elementClass comment asString! !

MDSqueakElementAdaptor subclass: #MDSqueakClassVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:49'!
isPresent
	^ self elementClass classVarNames includes: element name! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 14:00'!
load: properties
	self isPresent ifFalse: [self elementClass addClassVarName: element name]! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:59'!
remove
	self isPresent ifTrue: [self elementClass removeClassVarName: element name]! !

!MDSqueakElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 12/11/2005 10:57'!
forElement: anElement
	^ self forElement: anElement inSystem: Smalltalk! !

!MDSqueakElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 12/1/2005 21:58'!
forElement: anElement inSystem: aSystemEditor
	^ self new setElement: anElement system: aSystemEditor! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 3/11/2005 23:11'!
author
	| author |
	author _ self stamp copyUpTo: $ .
	^ author isEmpty ifFalse: [author] ifTrue: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 3/2/2006 18:08'!
display: properties
	^ properties asString! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:44'!
elementClass
	^ self elementClassIfAbsent: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 12/11/2005 11:01'!
elementClassIfAbsent: aBlock
	^ system at: element theClassName ifAbsent: aBlock! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 21:40'!
is: name upToDateIn: properties
	^ (properties at: name ifAbsent: [^ true]) = (self perform: name)
	! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:47'!
isLoadable: properties
	self elementClassIfAbsent: [^ false].
	^ true! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 21:40'!
isUpToDate: properties 
	self propertyNames
		do: [:property | (self is: property upToDateIn: properties) ifFalse: [^ false]].
	^ true
! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
load: properties
	self subclassResponsibility! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'avi 3/16/2005 12:21'!
merge: aPropertyDictionary into: otherPropertyDictionary onFailure: aBlock
	^ aBlock value! !

!MDSqueakElementAdaptor methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:39'!
propertyNames
	^ #()! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
remove
	self subclassResponsibility! !

!MDSqueakElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 12/1/2005 21:57'!
setElement: anElement system: aSystemEditor
	element _ anElement.
	system _ aSystemEditor! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 8/20/2005 19:32'!
stampFromProperties: properties
	| author timestamp |
	author _ properties at: #author ifAbsent: ['<nobody>'].
	timestamp _ properties at: #timeStamp ifAbsent: [^ '<no timestamp>'].
	^ timestamp printFormat: author, ' %l/%e/%Y %H:%M'
	! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 4/24/2006 14:12'!
timeStamp
	| stamp |
	stamp := self stamp.
	^ (#('' '<historical>' '<no timestamp>') includes: stamp)
		ifFalse: [MDTimestamp fromSqueakMethodStamp: stamp]
		ifTrue: [nil]
! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/1/2006 21:02'!
update: properties
	self propertyNames do: 
		[:name | (self perform: name) ifNotNilDo: 
			[:value | properties at: name put: value]]! !

MDSqueakElementAdaptor subclass: #MDSqueakInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

MDSqueakInstVarAdaptor subclass: #MDSqueakClassInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakClassInstVarAdaptor methodsFor: 'accessing' stamp: 'cwp 3/4/2005 15:04'!
elementClassIfAbsent: aBlock
	^ (super elementClassIfAbsent: aBlock) class! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 8/20/2005 18:21'!
isPresent
	^ (self elementClassIfAbsent: [^ false])
		instVarNames includes: element name! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:56'!
load: properties
	self isPresent ifFalse: [self elementClass addInstVarName: element name]! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:56'!
remove
	self isPresent ifTrue: [self elementClass removeInstVarName: element name]! !

MDSqueakElementAdaptor subclass: #MDSqueakLogAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakLogAdaptor methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 17:25'!
author
	^ Utilities authorInitials ! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/15/2005 23:00'!
isLoadable: properties
	^ true! !

!MDSqueakLogAdaptor methodsFor: 'testing' stamp: 'cwp 3/15/2005 22:39'!
isPresent
	^ true! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/15/2005 23:16'!
isUpToDate: properties
	^ false! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/15/2005 22:58'!
load: properties! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/23/2005 22:15'!
merge: properties into: other onFailure: aBlock
	other keys do: [:ea | other removeKey: ea].
	^ other! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/15/2005 23:07'!
remove! !

!MDSqueakLogAdaptor methodsFor: 'accessing' stamp: 'cwp 1/1/2007 23:34'!
slice
	^ MDSliceOrganizer default sliceWithId: element id! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 1/1/2007 23:33'!
update: properties
	MDLogRequest update: properties forSlice: self slice! !

MDSqueakElementAdaptor subclass: #MDSqueakMetadataAdaptor
	instanceVariableNames: ''
	classVariableNames: 'ImageMetadata'
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:37'!
atElement: anElement
	^ ImageMetadata at: anElement ifAbsent: [nil]! !

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:30'!
atElement: anElement putProperties: properties
	ImageMetadata at: anElement put: properties! !

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:38'!
elementIsPresent: anElement
	^ (self atElement: anElement) notNil! !

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:32'!
initialize
	ImageMetadata _ Dictionary new! !

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:36'!
removeElement: anElement
	^ ImageMetadata removeKey: anElement ifAbsent: [nil]! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:42'!
isLoadable: properties
	^ true! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:42'!
isPresent
	^ self class elementIsPresent: element! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:50'!
isUpToDate: properties
	(self class atElement: element)
		keysAndValuesDo: [:key :value | (properties at: key) = value ifFalse: [^ false]].
	^ true! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/23/2005 00:13'!
load: properties
	| copy |
	copy _ properties copy.
	copy versionNumber: copy versionNumber + 1.
	self class atElement: element putProperties: copy! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/23/2005 22:30'!
merge: properties into: other onFailure: aBlock
	properties branch = other branch ifFalse: [^ aBlock value].
	properties versionNumber > other versionNumber
		ifTrue: [other versionNumber: properties versionNumber].! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:46'!
remove
	self class removeElement: element! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:48'!
update: properties
	(self class atElement: element)
		keysAndValuesDo: [:key :value | properties at: key put: value]! !

MDSqueakElementAdaptor subclass: #MDSqueakMethodAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:06'!
category
	^ self elementClass organization categoryOfElement: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:44'!
compiledMethod 
	^ self elementClass compiledMethodAt: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/22/2006 19:49'!
display: properties
	^ properties source! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:24'!
elementClassIfAbsent: aBlock
	| nonMetaClass |
	nonMetaClass := super elementClassIfAbsent: aBlock.
	^ element classIsMeta
		ifTrue: [nonMetaClass class]
		ifFalse: [nonMetaClass]! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:22'!
isPresent
	^ self elementClass includesSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/14/2005 18:36'!
isUpToDate: aPropertyDictionary
	aPropertyDictionary localReference ifNotNilDo:
		[:compiledMethod |
		compiledMethod = self compiledMethod ifTrue: [^ true]].
	^ super isUpToDate: aPropertyDictionary! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 1/14/2006 18:05'!
load: properties
	| selector |
	selector _ self elementClass
					compile: (properties at: #source ifAbsent: [self source])
					classified: (properties at: #category ifAbsent: [self category])
					withStamp: (self stampFromProperties: properties)
					notifying: nil
					logSource: true.
! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:12'!
propertyNames
	^ #(author timeStamp category source)! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 8/14/2005 19:57'!
remove
	(self elementClassIfAbsent: [^ self])
		removeSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 3/11/2005 20:44'!
source
	^ (self elementClass sourceCodeAt: (element selector)) asString.! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:30'!
stamp
	^self compiledMethod timeStamp! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/14/2005 18:32'!
update: aPropertyDictionary
	super update: aPropertyDictionary.
	aPropertyDictionary localReference: self compiledMethod! !

MDSqueakElementAdaptor subclass: #MDSqueakPoolImportAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakPoolImportAdaptor methodsFor: 'private' stamp: 'cwp 12/22/2006 22:50'!
importedPool
	^ system at: element poolName.
	! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:34'!
isPresent
	^ self elementClass sharedPools anySatisfy: [:ea | ea name = element poolName]! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 12/23/2006 19:21'!
load: properties
	| class pool |
	class _ self elementClass.
	pool _ self importedPool.
	(class sharedPools includes: pool)
		ifFalse: [class addSharedPool: pool]! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:44'!
remove
	"Work around a bug in Class>>removeSharedPool:"
	
	self elementClass sharedPools remove: self importedPool ifAbsent: []! !

MDSqueakElementAdaptor subclass: #MDSqueakSliceAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakSliceAdaptor methodsFor: 'private' stamp: 'cwp 1/18/2007 23:34'!
definition
	^ (system sliceWithId: element id) definition.! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 1/18/2007 22:01'!
isLoadable: properties
	^ true! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 1/18/2007 22:57'!
isPresent
	^ system includesId: element id! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 1/18/2007 23:34'!
isUpToDate: properties
	^ self definition = properties
	! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 1/18/2007 23:13'!
load: properties
	(system sliceWithId: element id matches: properties)
		ifFalse: [system addSlice: (MDSlice forDefinition: properties)]! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 1/18/2007 23:19'!
remove
	system removeId: element id! !

!MDSqueakSliceAdaptor methodsFor: 'public' stamp: 'cwp 1/18/2007 23:33'!
update: properties
	| definition |
	definition _ self definition.
	properties keys do: 
		[:ea | 
		(definition includesKey: ea) 
			ifFalse: [properties removeKey: ea]].
	definition keysAndValuesDo:
		[:k :v | properties at: k put: v]! !

!Object methodsFor: '*mc2-squeak-ui' stamp: 'cwp 4/25/2005 04:04'!
displayOn: aStream
	self printOn: aStream! !

!Object methodsFor: '*mc2-squeak-ui' stamp: 'cwp 4/25/2005 04:03'!
displayString
	^ String streamContents: [:stream | self displayOn: stream]! !

MDImageProxy subclass: #MDSqueakImageProxy
	instanceVariableNames: 'editor slices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:46'!
adaptorForClassCommentElement: anElement
	^ MDSqueakClassCommentAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:43'!
adaptorForClassElement: anElement
	^ MDSqueakClassAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:49'!
adaptorForClassInstVarElement: anElement
	^ MDSqueakClassInstVarAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:48'!
adaptorForClassVarElement: anElement
	^ MDSqueakClassVarAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:50'!
adaptorForInstVarElement: anElement
	^ MDSqueakInstVarAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:57'!
adaptorForMetadataElement: anElement
	^ MDSqueakMetadataAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:53'!
adaptorForMethodElement: anElement
	^ MDSqueakMethodAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/2/2006 20:54'!
adaptorForPoolImportElement: anElement
	^ MDSqueakPoolImportAdaptor forElement: anElement inSystem: editor! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 1/19/2007 20:22'!
adaptorForSliceElement: anElement
	^ MDSqueakSliceAdaptor forElement: anElement inSystem: self slices! !

!MDSqueakImageProxy methodsFor: 'initialize-release' stamp: 'cwp 3/2/2006 21:06'!
initialize
	editor _ Smalltalk! !

!MDSqueakImageProxy methodsFor: 'accessing' stamp: 'cwp 1/19/2007 20:23'!
slices
	^ slices ifNil: [MDSliceOrganizer default]! !

!MDSqueakImageProxy methodsFor: 'accessing' stamp: 'cwp 1/19/2007 20:24'!
slices: aSliceOrganizer
	slices _ aSliceOrganizer! !

!MDSqueakImageProxy methodsFor: 'public' stamp: 'cwp 12/23/2006 21:45'!
transaction: aBlock
	|  result tmp |
	tmp _ editor.
	[editor _ MDPlatform current systemEditor.
	result _ aBlock value.
	editor commit]
		ensure: [editor _ tmp].

	^ result! !

TestCase subclass: #MDAdaptorTest
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 11:53'!
isAbstract
	^ self name = #MDAdaptorTest! !

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2005 21:40'!
shouldInheritSelectors
	^ true! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:43'!
adaptor
	^ self adaptorForElement: self element! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/2/2006 18:05'!
adaptorClass
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 12/1/2005 22:17'!
adaptorForElement: anElement
	^ self adaptorClass forElement: anElement inSystem: self system! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
author
	^ self stamp copyUpTo: $ ! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:49'!
bogusClass
	^ MDBogusA! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 3/23/2005 00:03'!
canBeUnloadable
	^ true! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 3/2/2006 18:12'!
displayString
	^ self properties asString! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 2/1/2006 21:20'!
editDuring: aBlock
	aBlock value.
	system commit.! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 12/22/2006 22:26'!
setUp
	system _ MDPlatform current systemEditor! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 12/3/2005 23:00'!
system
	^ system! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 2/5/2005 20:53'!
tearDown
	self destroyObject! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 00:02'!
testClassMissing
	| adaptor |
	self canBeUnloadable 
		ifTrue: [adaptor := self adaptorForElement: self unloadableElement.
				self deny: (adaptor isLoadable: self properties)]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 18:09'!
testDisplay
	| actual |
	actual _ self adaptor display: self properties.
	self assert: actual = self displayString! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 14:45'!
testIsLoadable
	self assert: (self adaptor isLoadable: self properties)
! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:42'!
testIsPresent
	self createObject.
	self assert: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 00:10'!
testIsUpToDate
	self createObject.
	self assert: (self adaptor isUpToDate: self properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/11/2005 22:48'!
testLoad
	self editDuring: [self adaptor load: self properties].
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 21:07'!
testNotPresent
	self deny: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/12/2005 14:41'!
testNotUpToDate
	| properties |
	self propertyToChange ifNil: [^ self].
	self createObject.
	properties := self properties.
	properties at: self propertyToChange put: self changedValue.
	self deny: (self adaptor isUpToDate: properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/3/2005 23:14'!
testRemove
	self createObject.
	self editDuring: [self adaptor remove].
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/3/2005 23:16'!
testRemoveNotPresent
	self editDuring: [self adaptor remove].
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/11/2005 10:43'!
testUpdate
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self editDuring: [self adaptor update: properties].
	self assert: properties = self properties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 12/3/2005 23:17'!
testUpdateSideEffects
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self editDuring: [self adaptor update: properties].
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 4/9/2005 01:54'!
timeStamp
	^ MDTimestamp fromSqueakMethodStamp: self stamp! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 2/15/2005 15:56'!
unloadableElement
	self subclassResponsibility! !

MDAdaptorTest subclass: #MDSqueakClassAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:42'!
adaptorClass
	^ MDSqueakClassAdaptor ! !

!MDSqueakClassAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 11:55'!
assertObjectHasDefaultProperties
	| class |
	class := Smalltalk 
			at: self bogusClassName 
			ifAbsent: [self signalFailure: 'Class doesn''t exist'].
	self assert: class superclass name = self superclassName.
	self assert: class category = self category.
	self assert: class typeOfClass = self format! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:02'!
bogusClassName
	^ #MDBogusB! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 12:03'!
category
	^ #'Monticello2-Fakes'! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 15:05'!
changedValue
	^ #temp! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:16'!
classInstVars
	^ 'aleph beth'! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
classVariablesString
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:12'!
classVars
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:13'!
comment
	^ 'A politician''s comment: it fills the space, while saying nothing.'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:14'!
commentAuthor
	^ self commentStamp copyUpTo: $ ! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:15'!
commentStamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 4/9/2005 04:48'!
commentTimeStamp
	^ MDTimestamp fromSqueakMethodStamp: self commentStamp! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:08'!
createObject
	Object 
		subclass: self bogusClassName
		instanceVariableNames: self instanceVariablesString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:56'!
destroyObject
	(Smalltalk at: self bogusClassName ifAbsent: [^ self]) removeFromSystem! !

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 11:58'!
element
	^ MDClassElement className: self bogusClassName! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
format
	^ #normal! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
instanceVariablesString
	^'one two'! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:06'!
objectIsPresent
	^ Smalltalk hasClassNamed: self bogusClassName asString! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:18'!
properties
	^ MDPropertyDictionary new
		category: self category;
		format: self format;
		superclassName: self superclassName;
		yourself! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #category! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 23:52'!
sharedPoolsString
	^ 'MDBogusPoolA'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
superclassName
	^ #Object! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 16:06'!
testClassMissing
	| properties |
	properties _ self properties.
	properties superclassName: #MDNonExistentClass.
	self deny: (self adaptor isLoadable: properties)! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 12:05'!
testLoadingPreservesVars
	| class |
	self createObject.
	self adaptor load: self properties.
	class := Smalltalk at: self bogusClassName ifAbsent: [self assert: false].
	self assert: class instanceVariablesString = 'one two'.
	self assert: class classVariablesString = 'Alpha Beta'.
	self assert: class sharedPoolsString = self sharedPoolsString.! !

MDAdaptorTest subclass: #MDSqueakClassCommentAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:39'!
adaptorClass
	^ MDSqueakClassCommentAdaptor! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/12/2005 14:57'!
assertObjectHasDefaultProperties
	self assert: self bogusClass comment = self text.
	self assert: self bogusClass organization commentStamp = self stamp.! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:51'!
changedValue
	^ 'A different comment for MDBogusA.'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:27'!
createObject
	self bogusClass classComment: self text stamp: self stamp
! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 15:00'!
destroyObject
	self bogusClass organization classComment: nil stamp: nil! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:20'!
element
	^ MDClassCommentElement className: self bogusClass name! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:59'!
objectIsPresent
	^ self bogusClass hasComment! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:36'!
properties
	^ MDPropertyDictionary new
		at: #text put: self text;
		at: #author put: self author;
		at: #timeStamp put: self timeStamp;
		yourself! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #text! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:18'!
stamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 20:54'!
testTextAsString
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: (properties text isKindOf: String)! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
text
	^ 'A comment for MDBogusA'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^MDClassCommentElement className: #MDNonExistentClass! !

MDAdaptorTest subclass: #MDSqueakClassVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakClassVarAdaptor! !

!MDSqueakClassVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:04'!
assertObjectHasDefaultProperties
	self assert: self objectIsPresent! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
classVarName
	^ 'Beta'! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 13:31'!
createObject
	self bogusClass addClassVarName: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeClassVarName: self classVarName]! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:46'!
element
	^ MDClassVarElement 
		className: self bogusClass name 
		name: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
objectIsPresent
	^self bogusClass classVarNames includes: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:46'!
propertyToChange
	"Class variables have no properties and thus can never by out of date."

	^ nil 
	! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:01'!
unloadableElement
	^ MDClassVarElement className: #MDNonExistentClass name: #Foo! !

MDAdaptorTest subclass: #MDSqueakInstVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

MDSqueakInstVarAdaptorTest subclass: #MDSqueakClassInstVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/4/2005 15:05'!
adaptor
	^ MDSqueakClassInstVarAdaptor forElement: self element! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'accessing' stamp: 'cwp 3/4/2005 14:54'!
bogusClass
	^ super bogusClass class! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/4/2005 15:13'!
element
	^ MDClassInstVarElement 
		className: self bogusClass theNonMetaClass name 
		name: self instVarName! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constants' stamp: 'cwp 3/4/2005 14:54'!
instVarName
	^ 'beth'! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
adaptorClass
	^ MDSqueakInstVarAdaptor! !

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:56'!
assertObjectHasDefaultProperties
	self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:24'!
createObject
	self bogusClass addInstVarName: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:07'!
denyObjectIsPresent
	self deny: self objectIsPresent! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeInstVarName: self instVarName]! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:26'!
element
	^ MDInstVarElement 
		className: self bogusClass name 
		name: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:21'!
instVarName
	^'two'! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
objectIsPresent
	^self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 13:06'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	"An instance variable has no properties, thus it is always up-to-date"

	^ nil! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
unloadableElement
	^ MDInstVarElement 
		className: #MDNonExistentClass
		name: self instVarName! !

MDAdaptorTest subclass: #MDSqueakMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

MDSqueakMethodAdaptorTest subclass: #MDSqueakClassMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakClassMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:14'!
bogusClass
	^ super bogusClass class! !

!MDSqueakClassMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:21'!
element
	^ MDMethodElement 
		className: super bogusClass name
		selector: self theSelector
		classIsMeta: true! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakMethodAdaptor! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 8/20/2005 19:10'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass includesSelector: self theSelector).
	self assert: (self bogusClass organization categoryOfElement: self theSelector) = self category.
	self assert: (self bogusClass sourceCodeAt: self theSelector) = self source.
	self assert: (self bogusClass compiledMethodAt: self theSelector) timeStamp = self stamp.! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:24'!
category
	^ #temporary! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:06'!
changedValue
	^ #temp! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:52'!
createObject
	self bogusClass
		compile: self source
		classified: self category
		withStamp: self stamp
		notifying: nil
		logSource: true! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:15'!
destroyObject
	self bogusClass removeSelector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'configuration' stamp: 'cwp 10/23/2006 10:26'!
displayString
	^ self properties source! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:16'!
element
	^ MDMethodElement className: self bogusClass name selector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:07'!
objectIsPresent
	^self bogusClass includesSelector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:39'!
properties
	^ MDPropertyDictionary new
		author: self author;
		category: self category;
		source: self source;
		timeStamp: self timeStamp;
		yourself! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	^ #category! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:23'!
source
	^ 'method1
	^ 1'! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 8/20/2005 19:09'!
stamp
	^ 'abc 11/29/2004 14:44' ! !

!MDSqueakMethodAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 20:43'!
testSourceAsString
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: (properties source isKindOf: String)! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:14'!
theSelector
	^#method1! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:58'!
unloadableElement
	^ MDMethodElement className: #MDNonExistentClass selector: #foo! !

MDAdaptorTest subclass: #MDSqueakPoolImportAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:04'!
adaptorClass
	^ MDSqueakPoolImportAdaptor! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 23:45'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName])! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 22:56'!
createObject
	self bogusClass addSharedPool: self pool! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:09'!
destroyObject
	self bogusClass sharedPools remove: self pool ifAbsent: []! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 23:30'!
element
	^ MDPoolImportElement className: self bogusClass name poolName: self poolName! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:46'!
objectIsPresent
	^ self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName]! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:57'!
pool
	^ Smalltalk at: self poolName! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:59'!
poolName
	^ #MDBogusPoolB! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:37'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	"A pool import has no properties and is thus always up-to-date."
	^ nil! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^ MDPoolImportElement className: #MDNonExistentClass poolName: #Foo! !

MDAdaptorTest subclass: #MDSqueakSliceAdaptorTest
	instanceVariableNames: 'slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 21:54'!
adaptorClass
	^ MDSqueakSliceAdaptor! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 23:17'!
assertObjectHasDefaultProperties
	(system sliceWithId: slice id) definition = slice definition! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 21:47'!
canBeUnloadable
	^ false! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 23:19'!
changedValue
	^ 'Test2'! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 22:55'!
createObject
	system addSlice: slice! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 21:49'!
destroyObject
	! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 22:49'!
element
	^ MDSliceElement forSlice: slice! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 23:21'!
objectIsPresent
	^ system includesId: slice id! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 23:16'!
properties
	^ slice definition! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 23:18'!
propertyToChange
	^ #name! !

!MDSqueakSliceAdaptorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2007 22:45'!
setUp
	system _ MDSliceOrganizer new.
	slice _ MDExplicitSlice named: 'Test Slice'! !

TestCase subclass: #MDCommentDialogTest
	instanceVariableNames: 'model widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDCommentDialogTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 01:03'!
meta
	^ MDPropertyDictionary new
		author: 'abc';
		ordinal: 23;
		comment: 'This was a spectacular commit.';
		yourself! !

!MDCommentDialogTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 16:02'!
setUp
	model _ MDCommentDialog slice: self slice meta: self meta.
	widget _ SUnitToolBuilder new build: model.! !

!MDCommentDialogTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 01:03'!
slice
	^ MDPropertyDictionary new
		name: 'TestSlice';
		type: #Explicit;
		yourself! !

!MDCommentDialogTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 16:26'!
testDefaultComment
	| text |
	text _ (widget widgetNamed: 'message') text.
	self assert: text = 'enter log message here'! !

!MDCommentDialogTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/29/2006 22:39'!
testExtent
	self assert: widget extent = (400@400)! !

!MDCommentDialogTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 14:06'!
testSelection
	| text selection |
	text _ (widget widgetNamed: 'message') text.
	selection _ (widget widgetNamed: 'message') selection.
	self assert: text size = selection size! !

!MDCommentDialogTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/31/2006 01:10'!
testVersionName
	| text |
	text _ (widget widgetNamed: 'name') text.
	self assert: text = 'TestSlice-abc.23'! !

TestCase subclass: #MDSlicePanelTest
	instanceVariableNames: 'model root status messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSlicePanelTest methodsFor: 'running' stamp: 'cwp 9/4/2005 00:48'!
listItems
	^ self listWidget list asSet collect: [:ea | ea asString].! !

!MDSlicePanelTest methodsFor: 'running' stamp: 'cwp 8/24/2005 21:31'!
listWidget
	^ root widgetNamed: 'slices'! !

!MDSlicePanelTest methodsFor: 'callbacks' stamp: 'cwp 9/4/2005 00:31'!
name
	^ 'Gamma'! !

!MDSlicePanelTest methodsFor: 'callbacks' stamp: 'cwp 10/16/2005 12:15'!
request: aString
	^ 'testfile'! !

!MDSlicePanelTest methodsFor: 'callbacks' stamp: 'cwp 8/29/2005 21:40'!
save
	messages add: #save! !

!MDSlicePanelTest methodsFor: 'callbacks' stamp: 'cwp 10/16/2005 12:28'!
saveFrom: aMDWorkingCopy toFileNamed: aByteString 
	messages add: #saveFrom:toFileNamed:! !

!MDSlicePanelTest methodsFor: 'running' stamp: 'cwp 9/4/2005 00:42'!
setUp
	status := MDSliceStatus forSlice: self of: MDWorkingCopy new.
	model _ MDSlicePanel new
		addStatus: (self statusFor: 'Alpha');
		addStatus: (self statusFor: 'Beta');
		addStatus: status;
		yourself.

	root _ SUnitToolBuilder new build: model.
	messages _ OrderedCollection new.! !

!MDSlicePanelTest methodsFor: 'running' stamp: 'cwp 8/24/2005 22:32'!
statusFor: aString
	^ MDSliceStatus
		forSlice: (MDExplicitSlice named: aString)
		of: MDWorkingCopy new.! !

!MDSlicePanelTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:48'!
testList

	self assert: self listItems = #('  Alpha' '  Beta' '  Gamma') asSet.! !

!MDSlicePanelTest methodsFor: 'tests' stamp: 'cwp 8/24/2005 21:32'!
testListSelection
	
	self listWidget clickItemAt: 1.
	self assert: self listWidget selectedIndex = 1.
	! !

!MDSlicePanelTest methodsFor: 'tests' stamp: 'cwp 10/15/2005 12:17'!
testSaveAction
	
	self listWidget clickItemAt: 3.
	self listWidget menu click: 'save to repository'.
	self assert: messages first = #save.
! !

!MDSlicePanelTest methodsFor: 'tests' stamp: 'cwp 10/16/2005 12:29'!
testSaveToFileMenuItem
	
	status beDirty.
	model changed: #sliceList.
	self assert: self listItems = #('  Alpha' '  Beta' '* Gamma') asSet.

	self listWidget clickItemAt: 3.
	[self listWidget menu click: 'save to file']
		on: UIManagerRequest 
		do: [:ex | ex resume: self].
	self assert: messages first = #saveFrom:toFileNamed:.
	
	self assert: self listItems = #('  Alpha' '  Beta' '  Gamma') asSet.

! !

!MDSlicePanelTest methodsFor: 'tests' stamp: 'cwp 10/15/2005 12:20'!
testSaveToRepoMenuItem
	
	status beDirty.
	model changed: #sliceList.
	self assert: self listItems = #('  Alpha' '  Beta' '* Gamma') asSet.

	self listWidget clickItemAt: 3.
	self listWidget menu click: 'save to repository'.
	self assert: messages first = #save.
	
	self assert: self listItems = #('  Alpha' '  Beta' '  Gamma') asSet.

! !

TestCase subclass: #MDSliceStatusTest
	instanceVariableNames: 'status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSliceStatusTest methodsFor: 'support' stamp: 'cwp 8/26/2005 18:39'!
inClass
	^MDFakeClass basedOn: MDBogusA! !

!MDSliceStatusTest methodsFor: 'support' stamp: 'cwp 8/26/2005 18:41'!
outClass
	^MDFakeClass basedOn: self class! !

!MDSliceStatusTest methodsFor: 'running' stamp: 'cwp 8/25/2005 20:32'!
setUp
	status := MDSliceStatus
				forSlice: self slice
				of: self! !

!MDSliceStatusTest methodsFor: 'support' stamp: 'cwp 9/5/2005 20:27'!
slice
	| inClassName outClassName |
	inClassName := self inClass name.
	outClassName := self class name.
	^(MDExplicitSlice named: 'Alpha')
		addElement: (MDClassElement className: inClassName);
		addElement: (MDClassCommentElement className: outClassName);
		addElement: (MDMethodElement className: outClassName selector: #method1);
		addElement: (MDMethodElement className: outClassName selector: #a classIsMeta: true);
		addElement: (MDInstVarElement className: outClassName name: 'two');
		addElement: (MDClassVarElement className: outClassName name: 'Beta');
		addElement: (MDClassInstVarElement className: outClassName name: 'bet');
		addElement: (MDPoolImportElement className: outClassName name: #MDBogusPoolB);
		yourself! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/24/2005 23:17'!
testCleanNoStar
	status beDirty.
	status beClean.
	self assert: status displayString = '  Alpha'! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/24/2005 23:17'!
testDefaultsClean
	self assert: status displayString = '  Alpha'! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/24/2005 23:15'!
testDirtyStar
	status beDirty.
	self assert: status displayString = '* Alpha'! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testInClass
	| event |
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: MDBogusA
				to: MDBogusA.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testInClassInstVar
	| event copy original |
	original := self outClass theMetaClass.
	copy := original copy.
	copy addInstVarName: 'bet'.
	status beClean.
	event := ModifiedEvent classDefinitionChangedFrom: original to: copy.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 20:10'!
testInClassMethod
	| event |
	status beClean.
	event := ModifiedEvent
				methodChangedFrom: nil
				to: nil
				selector: #a 
				inClass: self class class.
	status methodModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testInClassVar
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addClassVarName: 'Beta'.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/5/2005 20:30'!
testInComment
	| event |
	status beClean.
	event := CommentedEvent class: self outClass.
	status classCommented: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testInInstVar
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addInstVarName: 'two'.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 20:09'!
testInMethod
	| event |
	status beClean.
	event := ModifiedEvent
				methodChangedFrom: nil
				to: nil
				selector: #method1 
				inClass: MDSliceStatusTest.
	status methodModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testInPoolImport
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addSharedPool: MDBogusPoolB.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testOutClass
	| event |
	status beClean.
	event := ModifiedClassDefinitionEvent 
				classDefinitionChangedFrom: self outClass
				to: self outClass.
	status classModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testOutClassInstVar
	| event copy original |
	original := self outClass theMetaClass.
	copy := original copy.
	copy addInstVarName: 'gimmel'.
	status beClean.
	event := ModifiedEvent classDefinitionChangedFrom: original to: copy.
	status classModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 20:11'!
testOutClassMethod
	| event |
	status beClean.
	event := ModifiedEvent 
				methodChangedFrom: nil
				to: nil
				selector: #doesntExist
				inClass: self inClass class.
	status methodModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testOutClassVar
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addClassVarName: 'Gamma'.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/5/2005 20:31'!
testOutComment
	| event |
	status beClean.
	event := CommentedEvent class: self inClass.
	status classCommented: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testOutInstVar
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addInstVarName: 'three'.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/26/2005 21:42'!
testOutMethod
	| event |
	status beClean.
	event := ModifiedEvent 
				methodChangedFrom: nil
				to: nil
				selector: #doesntExist
				inClass: self inClass.
	status methodModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testOutPoolImport
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addSharedPool: MDBogusPoolA.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self deny: status isDirty! !

TestCase subclass: #MDSqueakTransactionTest
	instanceVariableNames: 'proxy commitWasCalled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakTransactionTest methodsFor: 'asserting' stamp: 'cwp 3/2/2006 20:45'!
assertEditorSetFor: aBlock
	| adaptor |
	proxy instVarNamed: 'editor' put: self.
	adaptor _ (aBlock value) adaptedFor: proxy.
	self assert: (adaptor instVarNamed: 'system') == self! !

!MDSqueakTransactionTest methodsFor: 'callbacks' stamp: 'cwp 3/2/2006 18:33'!
commit
	commitWasCalled _ true! !

!MDSqueakTransactionTest methodsFor: 'running' stamp: 'cwp 3/3/2006 15:31'!
endTransactionEarly
	proxy transaction: [^ self].! !

!MDSqueakTransactionTest methodsFor: 'running' stamp: 'cwp 3/2/2006 20:42'!
setUp
	proxy _ MDSqueakImageProxy new.
	commitWasCalled _ false! !

!MDSqueakTransactionTest methodsFor: 'callbacks' stamp: 'cwp 3/2/2006 21:06'!
subject
	^ Smalltalk! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:45'!
testEditorSetForClassAdaptors
	self assertEditorSetFor: [MDClassElement className: self class name].! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:45'!
testEditorSetForClassCommentAdaptors
	self assertEditorSetFor: [MDClassCommentElement className: self class name]! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:48'!
testEditorSetForClassInstVarAdaptors
	self assertEditorSetFor: [MDClassInstVarElement 
							className: self class name 
							name: 'aleph']! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:49'!
testEditorSetForClassVarAdaptors
	self assertEditorSetFor: [MDClassVarElement 
							className: self class name 
							name: 'Alpha']! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:50'!
testEditorSetForInstVarAdaptors
	self assertEditorSetFor: [MDInstVarElement 
							className: self class name 
							name: 'one']! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:52'!
testEditorSetForMethodAdaptors
	self assertEditorSetFor: [MDMethodElement 
							className: self class name 
							selector: #a]! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:54'!
testEditorSetForPoolImportAdaptors
	self assertEditorSetFor: [MDPoolImportElement 
							className: self class name 
							poolName: #MDBogusPoolA]! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 1/19/2007 20:22'!
testEditorSetForSliceAdaptor
	| adaptor |
	proxy instVarNamed: 'slices' put: self.
	adaptor _ (MDSliceElement forSlice: (MDExplicitSlice named: 'slice')) adaptedFor: proxy.
	self assert: (adaptor instVarNamed: 'system') == self
! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 12/24/2006 23:12'!
testProxyClearsEditorIfTransactionExitsEarly
	
	self endTransactionEarly.
	self assert: (proxy instVarNamed: 'editor') == Smalltalk! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 12/22/2006 22:37'!
testProxyCreatesSystemEditor
	| editor |
	proxy transaction:
		[editor _ proxy instVarNamed: 'editor'.
		self assert: (editor class == MDPlatform current systemEditor class)].! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 21:04'!
testProxyHasDefaultEnvironment
	
	self assert: (proxy instVarNamed: 'editor') == Smalltalk! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 12/24/2006 23:12'!
testProxyRemovesSystemEditor
	proxy transaction: ["do nothing"].
	self assert: (proxy instVarNamed: 'editor') == Smalltalk! !

!MDSqueakTransactionTest methodsFor: 'tests' stamp: 'cwp 3/2/2006 20:42'!
testProxySendsCommitToEditor
	
	proxy transaction: [proxy instVarNamed: 'editor' put: self].
	self assert: commitWasCalled! !

MDSliceTest subclass: #MDPackageSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDPackageSliceTest commentStamp: 'cwp 3/3/2005 02:10' prior: 0!
This comment needs to be here, or #testComment won't pass.!

!MDPackageSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 02:14'!
bogusMethodA
	"This method needs to be here for #testClassMethods to pass"! !

!MDPackageSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 02:14'!
bogusMethodB
	"This method needs to be here for #testClassMethods to pass"! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 00:33'!
classes
	^ Array with: MDBogusA with: MDSliceTest! !

!MDPackageSliceTest methodsFor: 'constructing' stamp: 'cwp 3/3/2006 14:23'!
createSlice
	^MDPackageInfoSlice forPackage: self! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 01:13'!
includesClassNamed: aSymbol
	^ self classes anySatisfy: [:ea | ea name = aSymbol]! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 01:30'!
includesMethodReference: aMethodReference 
	^ self methods includes: aMethodReference! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 00:43'!
methods
	^ Array
		with: (MethodReference class: MDSliceTest selector: #classes)
		with: (MethodReference class: MDSliceTest selector: #methods)
		with: (MethodReference class: MDSliceTest class selector: #bogusMethodA)
		with: (MethodReference class: MDSliceTest class selector: #bogusMethodB)
! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 3/16/2005 01:09'!
packageName
	^ 'TestPackage'! !

!MDPackageSliceTest methodsFor: 'tests' stamp: 'cwp 3/3/2006 13:35'!
testIncludedComments
	self 
		assertAllOf: #(MDBogusA MDSliceTest)
		butNoneOf: #(Object)
		includedAs: [:name | MDClassCommentElement className: name]! !

MDAdaptionTest subclass: #MDSqueakAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDSqueakAdaptionTest methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:33'!
proxyClass
	^ MDSqueakImageProxy! !

!UIManager class methodsFor: '*mc2-squeak' stamp: 'cwp 10/16/2005 12:11'!
current
	^ UIManagerRequest signal! !

MDProxyTest subclass: #MDMergeToolTest
	instanceVariableNames: 'wc model widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Tests'!

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 6/3/2005 08:29'!
assertIsBold: aTextOrString 
	self assert: (self isBold: aTextOrString)! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 6/15/2005 08:20'!
assertTextWidgetIsImmutable: aWidget 
	| expected actual |
	expected := aWidget text.
	aWidget accept: 'some text'.
	actual := aWidget text.
	self assert: actual = expected! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 5/30/2005 23:20'!
assertWidgetNamed: name hasText: contents
	^ self assertWidgetNamed: name hasText: contents forElement: 'Alpha'! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 5/30/2005 23:19'!
assertWidgetNamed: name hasText: contents forElement: element
	| text |
	(self widgetNamed: 'elements') click: element.
	text _ (self widgetNamed: name) text.
	self assert: text = contents! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 3/2/2006 15:45'!
buildAlpha
	| alpha |
	alpha := self versionFor: #Alpha with: #alphaRemote.
	wc loadVersion: (self 
						updateVersion: alpha
						property: #one
						put: #alphaLocal).
	^alpha! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 4/25/2005 03:24'!
buildBeta
	| beta element |
	element := self element: #Beta.
	self 
		atElement: element
		property: #one
		put: #betaLocal.
	beta := wc versionForElement: element.
	^self 
		updateVersion: beta
		property: #one
		put: #betaRemote! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 4/25/2005 03:23'!
buildGamma
	| gamma |
	self 
		atElement: (self element: #Gamma)
		property: #one
		put: #gammaLocal.
	gamma := self versionFor: #Gamma with: #gammaRemote.
	^gamma! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 6/3/2005 08:29'!
denyIsBold: aTextOrString 
	self deny: (self isBold: aTextOrString)! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 6/3/2005 08:29'!
isBold: aTextOrString 
	^(aTextOrString asText emphasisAt: 1) = 1! !

!MDMergeToolTest methodsFor: 'accessing' stamp: 'cwp 8/6/2005 20:29'!
mergeForListItem: item 
	^model merges detect: [:merge | merge displayString = item asString]! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 4/25/2005 03:23'!
merges
	| alpha beta gamma |
	alpha := self buildAlpha.
	beta := self buildBeta.
	gamma := self buildGamma.
	^Array 
		with: (MDMerge toInclude: alpha in: wc)
		with: (MDMerge toInclude: beta in: wc)
		with: (MDMerge toInclude: gamma in: wc)! !

!MDMergeToolTest methodsFor: 'accessing' stamp: 'cwp 3/2/2006 17:51'!
model
	^ model! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 3/2/2006 14:59'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.
	model _ MDMergeTool on: self merges in: wc.
	widget _ SUnitToolBuilder new build: model.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:10'!
testAlphaMenuItems
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Alpha'.
	self deny: (list menu labels includes: 'choose local').
	self assert: (list menu labels includes: 'choose remote').
! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:11'!
testBetaMenuItems
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Beta'.
	self assert: (list menu labels includes: 'choose local').
	self deny: (list menu labels includes: 'choose remote').
! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:01'!
testChooseLocal
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Gamma'.
	list menu click: 'choose local'.
	self denyIsBold: (list list detect: [:ea | ea asString = 'Gamma']).
	self assert: (self widgetNamed: 'resolved') text = 'gammaLocal'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/9/2005 09:00'!
testChooseRemote
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Gamma'.
	list menu click: 'choose remote'.
	self denyIsBold: (list list detect: [:ea | ea asString = 'Gamma']).
	self assert: (self widgetNamed: 'resolved') text = 'gammaRemote'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/30/2005 23:21'!
testConflictResolvedText
	self 
		assertWidgetNamed: 'resolved' 
		hasText: '-- unresolved conflict --' 
		forElement: 'Gamma'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/3/2005 08:25'!
testConflictsBold
	| list |
	list := (self widgetNamed: 'elements') list.
	list do: 	[:item | 
			(self mergeForListItem: item) isConflict 
				ifTrue: [self assertIsBold: item]]! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/3/2005 08:35'!
testConflictsFirst
	| list count |
	count := (self merges select: [:ea | ea isConflict]) size.
	list := (self widgetNamed: 'elements') list.
	(list first: count) do: [:ea | self assertIsBold: ea].
	(list last: list size - count) do: [:ea | self denyIsBold: ea]! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:12'!
testGammaMenuItems
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Gamma'.
	self assert: (list menu labels includes: 'choose local').
	self assert: (list menu labels includes: 'choose remote').
! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 8/6/2005 20:35'!
testList
	| list |
	list := (self widgetNamed: 'elements') list.
	list := list asSet collect: [:ea | ea asString].
	self assert: list = #('Alpha' 'Beta' 'Gamma') asSet.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/27/2005 08:22'!
testListSelection
	widget := self widgetNamed: 'elements'.
	widget clickItemAt: 1.
	self assert: widget selectedIndex = 1.
	! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/30/2005 23:21'!
testLocalResolvedText
	self assertWidgetNamed: 'resolved' hasText: 'alphaLocal'.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/24/2005 08:13'!
testLocalText
	self assertWidgetNamed: 'local' hasText: 'alphaLocal'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/15/2005 08:21'!
testLocalTextIsImmutable
	(self widgetNamed: 'elements') click: 'Alpha'.
	self assertTextWidgetIsImmutable: (self widgetNamed: 'local')! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 12/22/2006 22:20'!
testMenuNoSelection
	| list |
	list _ self widgetNamed: 'elements'.
	self assert: list menu labels asArray = #('merge resolved').
	! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:20'!
testMergeAll
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Gamma'.
	list menu click: 'choose local'.
	list menu click: 'merge resolved'.
	self assert: list list isEmpty.
	self assert: (self widgetNamed: 'local') text isEmpty.
	self assert: (self widgetNamed: 'remote') text isEmpty.
	self assert: (self widgetNamed: 'resolved') text isEmpty.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 16:34'!
testMergeResolved
	| list |
	list _ self widgetNamed: 'elements'.
	list menu click: 'merge resolved'.
	self assert: list list = #('Gamma')
! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/30/2005 23:22'!
testRemoteResolvedText
	self assertWidgetNamed: 'resolved' hasText: 'betaRemote' forElement: 'Beta'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/24/2005 08:14'!
testRemoteText
	self assertWidgetNamed: 'remote' hasText: 'alphaRemote'.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/15/2005 08:21'!
testRemoteTextIsImmutable
	(self widgetNamed: 'elements') click: 'Alpha'.
	self assertTextWidgetIsImmutable: (self widgetNamed: 'remote')! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/24/2005 08:15'!
testResolvedText
	self assertWidgetNamed: 'resolved' hasText: 'alphaLocal'.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/15/2005 08:25'!
testResolvedTextIsImmutable
	"This is just temporary. Eventually this should be editable."

	(self widgetNamed: 'elements') click: 'Alpha'.
	self assertTextWidgetIsImmutable: (self widgetNamed: 'resolved')! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/9/2005 08:58'!
testSwitchResolution
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Beta'.
	list menu click: 'choose local'.
	self assert: (self widgetNamed: 'resolved') text = 'betaLocal'! !

!MDMergeToolTest methodsFor: 'accessing' stamp: 'cwp 12/24/2006 23:58'!
wc
	^ wc! !

!MDMergeToolTest methodsFor: 'accessing' stamp: 'cwp 4/25/2005 03:57'!
widgetNamed: aString
	^ widget widgetNamed: aString! !

!Collection methodsFor: '*mc2-squeak' stamp: 'cwp 8/26/2005 21:58'!
disjoin: aCollection
	^ (self union: aCollection) difference: (self intersection: aCollection)! !

!SystemDictionary methodsFor: '*mc2-squeak' stamp: 'cwp 12/22/2006 22:35'!
commit
	! !

Notification subclass: #MDLogRequest
	instanceVariableNames: 'slice log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Adaptors'!

!MDLogRequest class methodsFor: 'signalling' stamp: 'cwp 1/1/2007 23:50'!
update: properties forSlice: aSlice
	^ (self new setProperties: properties slice: aSlice) signal! !

!MDLogRequest methodsFor: 'accessing' stamp: 'cwp 1/1/2007 23:48'!
askForComment
	^ self clearCursorDuring: [(MDCommentDialog slice: slice) openModally]
	! !

!MDLogRequest methodsFor: 'accessing' stamp: 'cwp 1/1/2007 14:26'!
clearCursorDuring: aBlock
	| cursor |
	cursor _ ActiveHand temporaryCursor.
	^ [ActiveHand showTemporaryCursor: nil.
	aBlock value]
		ensure: [ActiveHand showTemporaryCursor: cursor]! !

!MDLogRequest methodsFor: 'accessing' stamp: 'cwp 1/1/2007 15:28'!
defaultAction
	self updateWithUserComment! !

!MDLogRequest methodsFor: 'accessing' stamp: 'cwp 12/31/2006 17:48'!
log
	^ log! !

!MDLogRequest methodsFor: 'accessing' stamp: 'cwp 1/1/2007 23:49'!
setProperties: logProps slice: aSlice

	log _ logProps.
	slice _ aSlice! !

!MDLogRequest methodsFor: 'accessing' stamp: 'cwp 12/31/2006 21:27'!
updateWithAuthor: aString1 ordinal: anInteger comment: aString2
	log 
		author: aString1;
		ordinal: anInteger;
		comment: aString2.
	self resume! !

!MDLogRequest methodsFor: 'accessing' stamp: 'cwp 1/1/2007 23:55'!
updateWithComment: aString
	slice incrementOrdinal.
	self 
		updateWithAuthor: Utilities authorInitials
		ordinal: slice ordinal
		comment: aString.
	! !

!MDLogRequest methodsFor: 'accessing' stamp: 'cwp 1/1/2007 23:54'!
updateWithUserComment
	self updateWithComment: self askForComment.
	! !

Notification subclass: #UIManagerRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-UI'!

!UIManagerRequest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2005 12:09'!
defaultAction
	self resume: UIManager default! !

SharedPool subclass: #MDBogusPoolA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!

Object subclass: #MDBogusA
	instanceVariableNames: 'one'
	classVariableNames: 'Alpha'
	poolDictionaries: 'MDBogusPoolA TextConstants ScheduledControllers'
	category: 'MC2-Squeak-Fakes'!

MDBogusA class
	instanceVariableNames: 'aleph'!

SharedPool subclass: #MDBogusPoolB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Fakes'!

MDSlice subclass: #MDPackageInfoSlice
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Squeak-Slices'!

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'abc 1/1/2007 01:03'!
forDefinition: properties
	^ self named: properties name! !

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'cwp 3/3/2005 00:49'!
forPackage: aPackage
	^ self basicNew setPackage: aPackage! !

!MDPackageInfoSlice class methodsFor: 'instance creation' stamp: 'cwp 8/28/2005 18:02'!
named: aString
	^ self forPackage: (PackageInfo named: aString)! !

!MDPackageInfoSlice class methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:34'!
type
	^ #Package! !

!MDPackageInfoSlice methodsFor: 'private' stamp: 'cwp 3/3/2006 14:27'!
class: aClass do: aBlock
	aBlock value: (MDClassElement className: aClass name).
	aClass hasComment ifTrue:
		[aBlock value: (MDClassCommentElement className: aClass name)].
	self 
		names: aClass instVarNames 
		collect: [:name | MDInstVarElement className: aClass name name: name]
		into: aBlock.
	self 
		names: aClass classVarNames
		collect: [:name | MDClassVarElement className: aClass name name: name]
		into: aBlock.
	self 
		names: aClass class instVarNames
		collect: [:name | MDClassInstVarElement className: aClass name name: name]
		into: aBlock.
	self
		names: aClass poolDictionaryNames
		collect: [:name | MDPoolImportElement className: aClass name poolName: name]
		into: aBlock! !

!MDPackageInfoSlice methodsFor: 'private' stamp: 'cwp 3/3/2006 11:15'!
classForElement: anElement
	^ (Smalltalk classNamed: anElement theClassName)! !

!MDPackageInfoSlice methodsFor: 'enumerating' stamp: 'cwp 1/18/2007 23:59'!
elementsDo: aBlock
	package classes do: [:class | self class: class do: aBlock].
	package methods do: [:ea | aBlock value: ea asElement].! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:06'!
includes: anElement
	^ anElement isIncludedInSlice: self! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:10'!
includesClass: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:09'!
includesClassComment: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:17'!
includesClassInstVar: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 3/3/2006 11:16'!
includesClassVar: anElement
	^ (package includesClassNamed: anElement theClassName)
		and: [(self classForElement: anElement) classVarNames includes: anElement name]! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:16'!
includesInstVar: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:24'!
includesMethod: anElement
	| ref |
	ref _ MethodReference new.
	ref 
		setClassSymbol: anElement theClassName
		classIsMeta: anElement classIsMeta
		methodSymbol: anElement selector
		stringVersion: ''.
	^ package includesMethodReference: ref! !

!MDPackageInfoSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:32'!
includesPoolImport: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageInfoSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:26'!
name
	^ package packageName! !

!MDPackageInfoSlice methodsFor: 'private' stamp: 'cwp 3/3/2005 01:48'!
names: aCollection collect: mapBlock into: doBlock
	| elements |
	elements := aCollection collect: mapBlock.
	elements do: doBlock. 
		! !

!MDPackageInfoSlice methodsFor: 'initialize-release' stamp: 'cwp 1/19/2007 22:59'!
setPackage: aPackage
	package _ aPackage.
	self initId.! !
MDSqueakMetadataAdaptor initialize!
